CPU, TPOOL_NTHREADS=4
;
; WRF-CHEM
;
;
; Specify window size
nxpix=958L
nypix=720L

SETPLOT='Z'
;read,'setplot?',setplot

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
; set color table
  loadct,45,file='color_ck.tbl'
  !p.background=254.
  !p.color=255.
mcolor=byte(!p.color)
mcolor=fix(mcolor)
if mcolor eq 0 then mcolor=255
col1=mcolor
icmm1=mcolor-1
icmm2=mcolor-2
if setplot eq 'x' then begin
   lc=mcolor
   window,4,xsize=nxpix,ysize=nypix
   device,retain=2,decomposed=0
endif
fxhr=[$
'00hr  Fx',$
'01hr  Fx',$
'02hr  Fx',$
'03hr  Fx',$
'04hr  Fx',$
'05hr  Fx',$
'06hr  Fx',$
'07hr  Fx',$
'08hr  Fx',$
'09hr  Fx',$
'10hr  Fx',$
'11hr  Fx',$
'12hr  Fx',$
'13hr  Fx',$
'14hr  Fx',$
'15hr  Fx',$
'16hr  Fx',$
'17hr  Fx',$
'18hr  Fx',$
'19hr  Fx',$
'20hr  Fx',$
'21hr  Fx',$
'22hr  Fx',$
'23hr  Fx',$
'24hr  Fx',$
'25hr  Fx',$
'26hr  Fx',$
'27hr  Fx',$
'28hr  Fx',$
'29hr  Fx',$
'30hr  Fx',$
'31hr  Fx',$
'32hr  Fx',$
'33hr  Fx',$
'34hr  Fx',$
'35hr  Fx',$
'36hr  Fx',$
'37hr  Fx',$
'38hr  Fx',$
'39hr  Fx',$
'40hr  Fx',$
'41hr  Fx',$
'42hr  Fx',$
'43hr  Fx',$
'44hr  Fx',$
'45hr  Fx',$
'46hr  Fx',$
'47hr  Fx',$
'48hr  Fx',$
'49hr  Fx',$
'50hr  Fx',$
'51hr  Fx',$
'52hr  Fx',$
'53hr  Fx',$
'54hr  Fx',$
'55hr  Fx',$
'56hr  Fx',$
'57hr  Fx',$
'58hr  Fx',$
'59hr  Fx',$
'60hr  Fx'$
]
fxpng=[$
'00',$
'01',$
'02',$
'03',$
'04',$
'05',$
'06',$
'07',$
'08',$
'09',$
'10',$
'11',$
'12',$
'13',$
'14',$
'15',$
'16',$
'17',$
'18',$
'19',$
'20',$
'21',$
'22',$
'23',$
'24',$
'25',$
'26',$
'27',$
'28',$
'29',$
'30',$
'31',$
'32',$
'33',$
'34',$
'35',$
'36',$
'37',$
'38',$
'39',$
'40',$
'41',$
'42',$
'43',$
'44',$
'45',$
'46',$
'47',$
'48',$
'49',$
'50',$
'51',$
'52',$
'53',$
'54',$
'55',$
'56',$
'57',$
'58',$
'59',$
'60'$
]
wrfanal='namconus.fil'
close,2
openr,2,wrfanal
nfiles=0
fdate=''
readf,2,fdate
nfiles=25
nfiles=61
nfiles=12
;
; build label
;
yr='20'+strmid(fdate,0,2)
mn=strmid(fdate,2,2)
dy=strmid(fdate,4,2)
nam_dir='/iliad/proxy/jimd/NAM/NCEP/nam.20'+fdate+'/18Z/'
;nam_dir='/iliad/proxy/bpierce/Met/NAM_CONUS/Pres/March_23_2017/'
;
; build starting julian day
;
year=fix(yr)
month=fix(mn)
day=fix(dy)
hour=18.
minute=0.
second=0.
jday0=julday(month,day-1,year,hour,minute,second)
jdaym1=jday0+1.*findgen(nfiles)/24.
jday0=julday(month,day,year,hour,minute,second)
jday=jday0+1.*findgen(nfiles)/24.
caldat,jday,month,day,year,hour,minute,second
yrs=strtrim(string(year),2)
mns=strtrim(string(month),2)
index=where(month lt 10)
if index(0) ne -1 then mns(index)='0'+mns(index)
dys=strtrim(string(day),2)
index=where(day lt 10)
if index(0) ne -1 then dys(index)='0'+dys(index)
hrs=strtrim(string(hour),2)
index=where(hour lt 10)
if index(0) ne -1 then hrs(index)='0'+hrs(index)
ifiles='nam_'+mns+'_'+dys+'_'+yrs+'_'+hrs+'Z.dat'
caldat,jdaym1,month,day,year,hour,minute,second
yrs=strtrim(string(year),2)
mns=strtrim(string(month),2)
index=where(month lt 10)
if index(0) ne -1 then mns(index)='0'+mns(index)
dys=strtrim(string(day),2)
index=where(day lt 10)
if index(0) ne -1 then dys(index)='0'+dys(index)
hrs=strtrim(string(hour),2)
index=where(hour lt 10)
if index(0) ne -1 then hrs(index)='0'+hrs(index)
ifilesm1='nam_'+mns+'_'+dys+'_'+yrs+'_'+hrs+'Z.dat'

;
; start at 18hr FX
;
icount=1
   ifile=ifiles(0)
mn=strmid(ifile,4,2)
dy=strmid(ifile,7,2)
yr=strmid(ifile,10,4)
hr=strmid(ifile,15,3)
label=hr+' '+yr+mn+dy
label0='18Z '+yr+mn+dy
pnglabel='model.namconus_4km.'+yr+mn+dy+'1800.'

for nf = 0, nfiles-1 do begin

   ifile=ifiles(nf)
   print,'processing surfaces for '+ifile
;
; build label
;
;nam_03_17_2017_05Z.dat
mn=strmid(ifile,4,2)
dy=strmid(ifile,7,2)
yr=strmid(ifile,10,4)
hr=strmid(ifile,15,3)
label=hr+' '+yr+mn+dy
openr,10,nam_dir+ifile,/f77
hour=0l
day=0l
month=0l
year=0l
readu,10,hour,day,month,year
nlon_nam=0l
nlat_nam=0l
nlev=0l
readu,10,nlon_nam,nlat_nam,nlev
alon_nam=fltarr(nlon_nam,nlat_nam)
alat_nam=fltarr(nlon_nam,nlat_nam)
pnmc=fltarr(nlev)
readu,10,alon_nam,alat_nam,pnmc
hgt=fltarr(nlon_nam,nlat_nam,nlev)
rh=fltarr(nlon_nam,nlat_nam,nlev)
tmp=fltarr(nlon_nam,nlat_nam,nlev)
ugrd=fltarr(nlon_nam,nlat_nam,nlev)
vgrd=fltarr(nlon_nam,nlat_nam,nlev)
vvel=fltarr(nlon_nam,nlat_nam,nlev)
readu,10,ugrd,vgrd,vvel,tmp,rh,hgt
mslp=fltarr(nlon_nam,nlat_nam)
zsfc=fltarr(nlon_nam,nlat_nam)
psfc=fltarr(nlon_nam,nlat_nam)
readu,10,mslp,zsfc,psfc
upbl=fltarr(nlon_nam,nlat_nam)
vpbl=fltarr(nlon_nam,nlat_nam)
r2m=fltarr(nlon_nam,nlat_nam)
land=fltarr(nlon_nam,nlat_nam)
hpbl=fltarr(nlon_nam,nlat_nam)
ppbl=fltarr(nlon_nam,nlat_nam)
pwat=fltarr(nlon_nam,nlat_nam)
apcp=fltarr(nlon_nam,nlat_nam)
readu,10,upbl,vpbl,r2m,land,ppbl,pwat,apcp,hpbl
close,10
help,alon_nam,alat_nam,pnmc,upbl,vpbl,r2m,land,ppbl,pwat,apcp,hpbl,psfc
index=where(psfc ne 9.99900e+20)
psfc(index)=psfc(index)/100.
;
; apcp accumulates every 3 hours
;
if icount eq 1 then apcp_old=0.*apcp
if icount ne 2 then apcp=apcp-apcp_old
;tdsfc=9.99900e+20+0.*psfc
;tsfc=9.99900e+20+0.*psfc
;rhsfc=r2m
;for i=0,nlon_nam-1 do begin
;for j=0,nlat_nam-1 do begin
;if psfc(i,j) ne 9.99900e+20 then begin
;rhsfc=interpol(rh(i,j,*),pnmc,psfc(i,j))
;tsfc(i,j)=interpol(tmp(i,j,*),pnmc,psfc(i,j))-273.
;;
;; compute dewpoint temperature
;;
;b=(alog(rhsfc(i,j)/100.) + ((17.27*tsfc(i,j))/(237.3 + tsfc(i,j))))/17.27
;bs=(alog(100./100.) + ((17.27*tsfc(i,j))/(237.3 + tsfc(i,j))))/17.27
;tdsfc(i,j)=tsfc(i,j)-(237.3*b)/(1.-b)
;endif
;endfor
;endfor
daymap=r2m
index=where(daymap ne 9.99900e+20)
print,max(daymap(index)),min(daymap(index))
model_species='RH2m'
model_layer='_SFC'
scale=1.
unit='[%]'
      lev=100.*findgen(31)/30.


pdir='/odyssey/proxy/bpierce/LMOS/PNG_images_NAMCONUS/'+fdate+'/'
pdir='./'
; Specify window size
nxpix=958L
nypix=720L

if setplot eq 'Z' then begin
;-------------------------------------------
set_plot,'Z'
device,set_resolution=[nxpix,nypix],z_buffer=0
win_nx=!d.x_size
win_ny=!d.y_size

;--------------------------------------------
; Insert the main script
;--------------------------------------------
endif
if setplot eq 'ps' then begin
   lc=0
   set_plot,'ps'
   xsize=nxpix/100.
   ysize=nypix/100.
   !p.font=0
   device,/landscape,bits=8,filename=pdir+pnglabel+fxpng(nf)+'.'+model_species+'.ps'
   device,/color
   device,/inch,xoff=4.25-ysize/2.,yoff=5.5+xsize/2.,$
          xsize=xsize,ysize=ysize
   !p.thick=1
   !p.charsize=1.
endif
mcolor=255
icmm2=mcolor-2
icmm1=mcolor-1
; PLOT
        !noeras=1
        !type=2^2+2^3
        !p.thick=1.5
level=lev
set_viewport,.1,.9,.1,.9
color=.2*icmm2+.8*icmm2*findgen(31)/30.
title=' NAM 3km '+model_species+' '+label
!p.charsize=1
!p.thick=2.
erase
;map_set,38,-97,0,/lambert,/us,/continents,limit=[22,-122,50,-70],/HIRES,$
map_set,/us,/continents,limit=[33.5,-119,34.5,-117],/HIRES,$
title=title,color=mcolor
loadct,39
contour,daymap,alon_nam,alat_nam,/overplot,level=level,/cell_fill,c_color=color
mapcolor=mcolor
map_set,limit=[33.5,-119,34.5,-117],$
/grid,latdel=1,londel=1,label=1,color=0,/noeras
!p.thick=1
contour,zsfc,alon_nam,alat_nam,level=250.*findgen(31),/overplot,color=0B
colors=mcolor+[0B]
!p.thick=2
       DrawCounties_white, 'co2000p020.shp', Statenames=['CA']
          Colors=colors
;
; this is the scale factor for the size of the wind vectors
;
maxmag=90.
vcolor=0.
nh=0
drawvectors,nlon_nam,nlat_nam,alon_nam,alat_nam,upbl,vpbl,maxmag,nh,vcolor
;Waypoint,                                                          Latitude,       Longitude
;Truax Field,    						   43.136464,      -89.345783
;Sheboygan County Municipal Airport,                               43.768872,      -87.852911
;Zion Ground Site,                                                 42.467689,      -87.810036
;Zion Offshore,                                                    42.467306,      -87.643986
;Zion Background,                                                  42.538050,      -88.668203
;Sheboygan Ground Site,                                            43.746214,      -87.707881
;Sheboygan Offshore,                                               43.746069,      -87.646194
;Sheboygan Background,                                             43.668344,      -88.113811
;Zion Background,                                                  42.538050,      -88.668203
;Kohler-Andrae Monitor,                                            43.667347,      -87.716269
;Kohler-Andrae Offshore,                                           43.666722,      -87.653539
;Oak Creek Offshore Waypoint,                                      42.843542,      -87.663944
;Milwaukee Offshore,                                               43.020800,      -87.652575
;Chicago offshore Waypoint,                                        42.247467,      -87.251989
;Chicago Background Waypoint,                                      42.445283,      -88.439006
;Oak Creek Coal Fired Power Plant,                                 42.844444,      -87.828611
;Milwaukee Background Waypoint,                                    42.841758,      -88.222867
;Waukesha Monitor,                                                 43.020108,      -88.215083
;Port Washington Gas Fired (or Coal/Gas) Generating Station,       43.384431,      -87.869714
;Port Washington Offshore,                                         43.384539,      -87.807222
;Port Washington Background Waypoint,                              43.494975,      -88.111892
;Edgewater Coal Fired Generating Station,                          43.715556,      -87.706389
; UCLA(34.074� N, 118.441�W)
; Los Angeles Main Street (34.066� N,118.227�W)
; CalTech (34.136� N, 118.127�W) 
; Pico Rivera (34.010�N, 118.069�W)
; Ontario (34.068� N, 117.526�W)
; Fontana (34.010� N, 117.492�W)
!psym=4
!p.thick=2
oplot,[-118.441,-118.227,-118.127,-118.069,-117.526,-117.492],[34.074,34.066,34.136,34.010,34.068,34.010],color=0B

!p.thick=1
; color bar
!p.charsize=1.
        !psym=0
        imin=min(level)
        imax=max(level)
        set_viewport,.1,.45,.09,.1
        !type=2^2+2^3+2^6
        plot,[imin,imax],[0,0],yrange=[0,10],xrange=[imin,imax],$
        xtitle='(%)',/noeras,color=mcolor
        ybox=[0,10,10,0,0]
        x2=imin
        dx=(imax-imin)/float(.8*icmm2)
loadct,39
        for j=2*icmm2/10,icmm2 do begin
            xbox=[x2,x2,x2+dx,x2+dx,x2]
            polyfill,xbox,ybox,color=j
            x2=x2+dx
        endfor
; color bar
!p.charsize=1.25
xyouts,imin,-85,'NAM-CONUS '+fxhr(nf)+' Initialized '+label0
image=tvrd(0,0,win_nx,win_ny)
image_byt=bytscl(image,min=0,max=255)
;transparent=bytarr(256)+255B
;transparent(255:255)=0
tvlct,r,g,b,/get

write_png,pdir+pnglabel+fxpng(nf)+model_layer+'_'+model_species+'.png',image_byt,r,g,b
endfor  ; end loop over nf files
end
